# $modulepath/templated_file/manifests/init.pp
define templated_file (
  $template,
  $template_format         = 'erb',
  $path                    = $title,
  $ensure                  = file,
  $backup                  = 'puppet',
  $checksum                = undef,
  $force                   = false,
  $group                   = undef,
  $ignore                  = undef,
  $links                   = 'manage',
  $mode                    = undef,
  $owner                   = undef,
  $provider                = undef,
  $purge                   = false,
  $replace                 = true,
  $selinux_ignore_defaults = undef,
  $selrange                = undef,
  $selrole                 = undef,
  $seltype                 = undef,
  $seluser                 = undef,
  $show_diff               = true,
  $sourceselect            = 'first',
  $validate_cmd            = undef,
  $validate_replacement    = '%',
) {
  file { $title:
    ensure                  => $ensure,
    path                    => $path,
    backup                  => $backup,
    checksum                => $checksum,
    force                   => $force,
    group                   => $group,
    ignore                  => $ignore,
    links                   => $links,
    mode                    => $mode,
    owner                   => $owner,
    provider                => $provider,
    purge                   => $purge,
    replace                 => $replace,
    selinux_ignore_defaults => $selinux_ignore_defaults,
    selrange                => $selrange,
    selrole                 => $selrole,
    seltype                 => $seltype,
    seluser                 => $seluser,
    show_diff               => $show_diff,
    sourceselect            => $sourceselect,
    validate_cmd            => $validate_cmd,
    validate_replacement    => $validate_replacement,
    content                 => $template_format ? {
      'erb'   => template($template),
      'epp'   => epp($template),
      default => fail('Please select \'erb\' or \'epp\' as a template_format.'),
    }
  }
}
